/*

English UCG Grammar

Copyright 1986, 1989 
University of Edinburgh,
Centre for Cognitive Science

These files may not be redistributed in any form 
without prior permission.

Contact: jo@uk.ac.ed.epistemi

Jonathan Calder
University of Edinburgh
Centre for Cognitive Science
2 Buccleuch Place
Edinburgh
Scotland
EH8 9LW

'SCCSId'('extra.lex', '1.3', '1').

*/
/*---------------------------------------------------------------------------+
|                                                                            |
|	 this file is a completely revamped version of 			     |
|        /mnt/jo/Acord/PIMPLE/Protolexicon/Lexicon/UCG/extra.lex	     |
|	 It contains all idioms that subcategorize for items from	     |
|	 Lex/lexwords.lex						     |	
|                                                                            |
|        Date of last edit: "Tue Jan 17, 1989" (marc)                        |
|        								     |
+---------------------------------------------------------------------------*/

capacity : [@ 'N1',
	    @ 'Neuter',
	    @ 'Abstract',
	    : category = [: remainder = [: feature = sg],
			  : active = [: phonology = load,
				      : category = lex,
				      : order = post]],
	    : semantics = [: predicate = load_capacity,
			   : arglist = `[]]].

capacity : [@ 'N1',
	    @ 'Neuter',
	    @ 'Abstract',
	    : category = [: remainder = [: feature = sg],
			  : active = [: phonology = storage,
				      : category = lex,
				      : order = post]],
	    : semantics = [: predicate = storage_capacity,
			   : arglist = `[]]].

computer : [@ 'N1',
	    @ 'Neuter',
	    @ 'Extended',
	    : category = [: remainder = [: feature = sg],
			  : active = [: phonology = personal,
				      : category = lex,
				      : order = post]],
	    : semantics = [: predicate = pc,
			   : arglist = `[]]].

constable : [@ 'N1',
	     @ 'Male',
	     @ 'Extended',
	     : category = [: remainder = [: feature = sg],
			   : active = [: phonology = police,
				       : category = lex,
				       : order = post]],
	     : semantics = [: predicate = police_constable,
			    : arglist = `[]]].

date : [@ 'N3',
	@ 'Neuter',
	: category = [: remainder = [: remainder = [: remainder = [: feature = sg],
						    : active = [: category = [: cat = pp,
									      : feature = of],
								: semantics = # 3,
								: order = post or opt]],
				     : active = [: phonology = delivery,
						 : category = lex,
						 : order = pre]],
		      : active = [: phonology = of,
				  : category = lex,
				  : order = pre]],
	: semantics = [: index = 1 # (@ 'Te'),
		       : predicate = and,
		       binary([: index = # 1,
				: predicate = time,
				: arglist = `[]], [: index = 2 # (@ 'Eve'),
						   : predicate = and,
						   binary([: index = # 2,
							    : predicate = temploc,
							    unary( # 1)], [: index = # 2,
									    : predicate = delivery,
									    unary(# 3)])])]].

date : [@ 'N1',
	@ 'Neuter',
	: category = [: remainder = [: feature = sg],
		      : active = [: phonology = delivery,
				  : category = lex,
				  : order = post]],
	: semantics = [: index = 1 # (@ 'Te'),
		       : predicate = and,
		       binary([: index = # 1,
				: predicate = time,
				: arglist = `[]], [: index = 2 # (@ 'Eve'),
						   : predicate = and,
						   binary([: index = # 2,
							    : predicate = temploc,
							    unary(# 1)], [: index = # 2,
									   : predicate = delivery,
									   unary([])])])]].

drive : [@ 'N1',
	 @ 'Neuter',
	 @ 'Extended',
	 : category = [: remainder = [: feature = sg],
		       : active = [: phonology = disk,
				   : category = lex,
				   : order = post]],
	 : semantics = [: predicate = disk_drive,
			: arglist = `[]]].

driver : [@ 'N1',
	  @ 'Neuter',
	  @ 'Extended',
	  : category = [: remainder = [: feature = sg],
			: active = [: phonology = truck,
				    : category = lex,
				    : order = post]],
	  : semantics = [: predicate = truck_driver,
			 : arglist = `[]]].

failure : [@ 'N1',
	   @ 'Neuter',
	   @ 'Extended',
	   : category = [: remainder = [: feature = sg],
			 : active = [: phonology = engine,
				     : category = lex,
				     : order = post]],
	   : semantics = [: predicate = engine_failure,
			  : arglist = `[]]].

hours : [@ 'N1',
	 @ 'Tmeasure',
	 : category = [: remainder = [: feature = pl],
		       : active = [: phonology = opening,
				   : category = lex,
				   : order = post]],
	 : semantics = [: predicate = opening_hours,
			: arglist = `[]]].

means : [@ 'N2',
	 @ 'Object',
	 @ 'Extended',
	 : category = [: remainder = [: remainder = [: feature = sg],
				      : active = [: phonology = transport,
						  : category = lex,
						  : order = pre]],
		       : active = [: phonology = of,
				   : category = lex,
				   : order = pre]],
	 : semantics = [: predicate = means_of_transport,
			: arglist = `[]]].

place : [@ 'N3',
	 @ 'Neuter',
	 : category = [: remainder = [: remainder = [: remainder = [: feature = sg],
						     : active = [: category = [: cat = pp,
									       : feature = of],
								 : semantics = # 3,
								 : order = post or opt]],
				      : active = [: phonology = departure,
						  : category = lex,
						  : order = pre]],
		       : active = [: phonology = of,
				   : category = lex,
				   : order = pre]],
	 : semantics = [: index = 1 # (@ 'Ex'),
			: predicate = and,
			binary([: index = # 1,
				 : predicate = place,
				 : arglist = `[]], [: index = 2 # (@ 'Eve'),
						    : predicate = and,
						    binary([: index = # 2,
							     : predicate = atloc,
							     unary(# 1)], [: index = # 2,
									    : predicate = depart,
									    unary(# 3)])])]].
place : [@ 'N3',
	 @ 'Neuter',
	 : category = [: remainder = [: remainder = [: remainder = [: feature = sg],
						     : active = [: category = [: cat = pp,
									       : feature = of],
								 : semantics = # 3,
								 : order = post or opt]],
				      : active = [: phonology = arrival,
						  : category = lex,
						  : order = pre]],
		       : active = [: phonology = of,
				   : category = lex,
				   : order = pre]],
	 : semantics = [: index = 1 # (@ 'Ex'),
			: predicate = and,
			binary([: index = # 1,
				 : predicate = place,
				 : arglist = `[]], [: index = 2 # (@ 'Eve'),
						    : predicate = and,
						    binary([: index = # 2,
							     : predicate = atloc,
							     unary(# 1)], [: index = # 2,
									    : predicate = arrive,
									    unary(# 3)])])]].
place : [@ 'N1',
	 @ 'Neuter',
	 : category = [: remainder = [: feature = sg],
		       : active = [: phonology = departure,
				   : category = lex,
				   : order = post]],
	 : semantics = [: index = 1 # (@ 'Ex'),
			: predicate = and,
			binary([: index = # 1,
				 : predicate = place,
				 : arglist = `[]], [: index = 2 # (@ 'Eve'),
						    : predicate = and,
						    binary([: index = # 2,
							     : predicate = atloc,
							     unary(# 1)], [: index = # 2,
									    : predicate = depart,
									    unary(`[])])])]].

place : [@ 'N1',
	 @ 'Neuter',
	 : category = [: remainder = [: feature = sg],
		       : active = [: phonology = arrival,
				   : category = lex,
				   : order = post]],
	 : semantics = [: index = 1 # (@ 'Ex'),
			: predicate = and,
			binary([: index = # 1,
				 : predicate = place,
				 : arglist = `[]], [: index = 2 # (@ 'Eve'),
						    : predicate = and,
						    binary([: index = # 2,
							     : predicate = atloc,
							     unary(# 1)], [: index = # 2,
									    : predicate = arrive,
									    unary(`[])])])]].

time : [@ 'N3',
	@ 'Neuter',
	: category = [: remainder = [: remainder = [: remainder = [: feature = sg],
						    : active = [: category = [: cat = pp,
									      : feature = of],
								: semantics = # 3,
								: order = post or opt]],
				     : active = [: phonology = departure,
						 : category = lex,
						 : order = pre]],
		      : active = [: phonology = of,
				  : category = lex,
				  : order = pre]],
	: semantics = [: index = 1 # (@ 'Te'),
		       : predicate = and,
		       binary([: index = # 1,
			        : predicate = time,
				: arglist = `[]], [: index = 2 # (@ 'Eve'),
						   : predicate = and,
						   binary([: index = # 2,
							    : predicate = temploc,
							    unary(# 1)], [: index = # 2,
									   : predicate = depart,
									   unary(# 3)])])]].

time : [@ 'N3',
	@ 'Neuter',
	: category = [: remainder = [: remainder = [: remainder = [: feature = sg],
						    : active = [: category = [: cat = pp,
									      : feature = of],
								: semantics = # 3,
								: order = post or opt]],
				     : active = [: phonology = arrival,
						 : category = lex,
						 : order = pre]],
		      : active = [: phonology = of,
				  : category = lex,
				  : order = pre]],
	: semantics = [: index = 1 # (@ 'Te'),
		       : predicate = and,
		       binary([: index = # 1,
				: predicate = time,
				: arglist = `[]], [: index = 2 # (@ 'Eve'),
						   : predicate = and,
						   binary([: index = # 2,
							    : predicate = temploc,
							    unary(# 1)], [: index = # 2,
									   : predicate = arrive,
									   unary(# 3)])])]].

time : [@ 'N1',
	@ 'Neuter',
	: category = [: remainder = [: feature = sg],
		      : active = [: phonology = departure,
				  : category = lex,
				  : order = post]],
	: semantics = [: index = 1 # (@ 'Te'),
		       : predicate = and,
		       binary([: index = # 1,
			        : predicate = time,
				: arglist = `[]], [: index = 2 # (@ 'Eve'),
						   : predicate = and,
						   binary([: index = # 2,
							    : predicate = temploc,
							    unary(# 1)], [: index = # 2,
									    : predicate = depart,
									    unary(`[])])])]].

time : [@ 'N1',
	@ 'Neuter',
	: category = [: remainder = [: feature = sg],
		      : active = [: phonology = arrival,
				  : category = lex,
				  : order = post]],
	: semantics = [: index = 1 # (@ 'Te'),
		       : predicate = and,
		       binary([: index = # 1,
			        : predicate = time,
				: arglist = `[]], [: index = 2 # (@ 'Eve'),
						   : predicate = and,
						   binary([: index = # 2,
							    : predicate = temploc,
							    unary(# 1)], [: index = # 2,
									   : predicate = arrive,
									   unary(`[])])])]].

unit : [@ 'N1',
	@ 'Neuter',
	@ 'Extended',
	: category = [: remainder = [: feature = sg],
		      : active = [: phonology = central,
				  : category = lex,
				  : order = post]],
	: semantics = [: predicate = cpu,
		       : arglist = `[]]].


/*

Added for ETW 88.

12/10/88 JC

*/

/*
load : [@ load1,'Bse'].
load : [@ load1,'Bse'].
load : [@ load1,'PluPres'].
load : [@ load1,'PluPres'].
load : [@ load1,'PluPres'].
loads : [@ load1,'3sg'].
loads : [@ load1,'3sg'].
loads : [@ load1,'3sg'].
loaded : [@ load1,'Past'].
loaded : [@ load1,'Past'].
loaded : [@ load1,'Past'].
loaded : [@ load1,'Passive'].
loaded : [@ load1,'Passive'].
loaded : [@ load1,'Passive'].
loaded : [@ load1,'Passive'].
loaded : [@ load1,'Perfect'].
loaded : [@ load1,'Perfect'].
loaded : [@ load1,'Perfect'].
loaded : [@ load1,'Perfect'].
loaded : [@ load1,'Perfect'].
loaded : [@ load1,'Perfect'].
loading : [@ load1,'Progressive'].
loading : [@ load1,'Progressive'].
loading : [@ load1,'Progressive'].
loading : [@ load1,'Progressive'].
loading : [@ load1,'Progressive'].
loading : [@ load1,'Progressive'].

load : [@ load2,'Bse'].
load : [@ load2,'Bse'].
load : [@ load2,'PluPres'].
load : [@ load2,'PluPres'].
load : [@ load2,'PluPres'].
loads : [@ load2,'3sg'].
loads : [@ load2,'3sg'].
loads : [@ load2,'3sg'].
loaded : [@ load2,'Past'].
loaded : [@ load2,'Past'].
loaded : [@ load2,'Past'].
loaded : [@ load2,'Passive'].
loaded : [@ load2,'Passive'].
loaded : [@ load2,'Passive'].
loaded : [@ load2,'Passive'].
loaded : [@ load2,'Perfect'].
loaded : [@ load2,'Perfect'].
loaded : [@ load2,'Perfect'].
loaded : [@ load2,'Perfect'].
loaded : [@ load2,'Perfect'].
loaded : [@ load2,'Perfect'].
loading : [@ load2,'Progressive'].
loading : [@ load2,'Progressive'].
loading : [@ load2,'Progressive'].
loading : [@ load2,'Progressive'].
loading : [@ load2,'Progressive'].
loading : [@ load2,'Progressive'].

reload : [@ reload,'Bse'].
reload : [@ reload,'Bse'].
reload : [@ reload,'PluPres'].
reload : [@ reload,'PluPres'].
reload : [@ reload,'PluPres'].
reloads : [@ reload,'3sg'].
reloads : [@ reload,'3sg'].
reloads : [@ reload,'3sg'].
reloaded : [@ reload,'Past'].
reloaded : [@ reload,'Past'].
reloaded : [@ reload,'Past'].
reloaded : [@ reload,'Passive'].
reloaded : [@ reload,'Passive'].
reloaded : [@ reload,'Passive'].
reloaded : [@ reload,'Passive'].
reloaded : [@ reload,'Perfect'].
reloaded : [@ reload,'Perfect'].
reloaded : [@ reload,'Perfect'].
reloaded : [@ reload,'Perfect'].
reloaded : [@ reload,'Perfect'].
reloaded : [@ reload,'Perfect'].
reloading : [@ reload,'Progressive'].
reloading : [@ reload,'Progressive'].
reloading : [@ reload,'Progressive'].
reloading : [@ reload,'Progressive'].
reloading : [@ reload,'Progressive'].
reloading : [@ reload,'Progressive'].

consist : [@ consist,'Bse'].
consist : [@ consist,'Bse'].
consist : [@ consist,'PluPres'].
consist : [@ consist,'PluPres'].
consist : [@ consist,'PluPres'].
consists : [@ consist,'3sg'].
consists : [@ consist,'3sg'].
consists : [@ consist,'3sg'].
consisted : [@ consist,'Past'].
consisted : [@ consist,'Past'].
consisted : [@ consist,'Past'].

put : [@ put_in,'Bse'].
put : [@ put_in,'Bse'].
put : [@ put_in,'PluPres'].
put : [@ put_in,'PluPres'].
put : [@ put_in,'PluPres'].
puts : [@ put_in,'3sg'].
puts : [@ put_in,'3sg'].
puts : [@ put_in,'3sg'].
put : [@ put_in,'Past'].
put : [@ put_in,'Past'].
put : [@ put_in,'Past'].
put : [@ put_in,'Passive'].
put : [@ put_in,'Passive'].
put : [@ put_in,'Passive'].
put : [@ put_in,'Passive'].
put : [@ put_in,'Perfect'].
put : [@ put_in,'Perfect'].
put : [@ put_in,'Perfect'].
put : [@ put_in,'Perfect'].
put : [@ put_in,'Perfect'].
put : [@ put_in,'Perfect'].
putting : [@ put_in,'Progressive'].
putting : [@ put_in,'Progressive'].
putting : [@ put_in,'Progressive'].
putting : [@ put_in,'Progressive'].
putting : [@ put_in,'Progressive'].
putting : [@ put_in,'Progressive'].

unload : [@ unload_from,'Bse'].
unload : [@ unload_from,'Bse'].
unload : [@ unload_from,'PluPres'].
unload : [@ unload_from,'PluPres'].
unload : [@ unload_from,'PluPres'].
unloads : [@ unload_from,'3sg'].
unloads : [@ unload_from,'3sg'].
unloads : [@ unload_from,'3sg'].
unloaded : [@ unload_from,'Past'].
unloaded : [@ unload_from,'Past'].
unloaded : [@ unload_from,'Past'].
unloaded : [@ unload_from,'Passive'].
unloaded : [@ unload_from,'Passive'].
unloaded : [@ unload_from,'Passive'].
unloaded : [@ unload_from,'Passive'].
unloaded : [@ unload_from,'Perfect'].
unloaded : [@ unload_from,'Perfect'].
unloaded : [@ unload_from,'Perfect'].
unloaded : [@ unload_from,'Perfect'].
unloaded : [@ unload_from,'Perfect'].
unloaded : [@ unload_from,'Perfect'].
unloading : [@ unload_from,'Progressive'].
unloading : [@ unload_from,'Progressive'].
unloading : [@ unload_from,'Progressive'].
unloading : [@ unload_from,'Progressive'].
unloading : [@ unload_from,'Progressive'].
unloading : [@ unload_from,'Progressive'].
*/
