/*

English UCG Grammar

Copyright 1986, 1989 
University of Edinburgh,
Centre for Cognitive Science

These files may not be redistributed in any form 
without prior permission.

Contact: jo@uk.ac.ed.epistemi

Jonathan Calder
University of Edinburgh
Centre for Cognitive Science
2 Buccleuch Place
Edinburgh
Scotland
EH8 9LW

'SCCSId'('pron.lex', '1.2', '1').

*/
/*---------------------------------------------------------------------------+
|        								     |
|        This is an unchanged copy of                                        |
|        /mnt1/jo/Acord/PIMPLE/Protolexicon/Lexicon/UCG/pron.lex             |
|        Created:           Mon Nov 24 18:38:10 1986			     |
|        By:                Jo Calder					     |
|        date of last edit: "Mon Nov 24 18:38:10 1986"			     |
|        								     |
|        This file includes personal, relative, reflexive, possessive and    |
|        demonstrative pronouns.  (Not necessarily in that order).	     |
|        								     |
+---------------------------------------------------------------------------*/
%RELATIVE PRONOUNS

who : [@ 'WHR',
       : cat1 : cat1 : category : feature : case = nom].

whom : [@ 'WHR',
	: cat1 : cat1 : category : feature : case = obj].

that : [@ 'WHR'].


which : [@ 'WHR'].


whose : [@ 'WHRELPOSS'].


where : [@ 'WHRELPP',
	 : category = [: active = [: category = [: active = [: category = [: feature = loc or adj]]]]],
	 : semantics = [: arglist = [: argrest = [: argfirst = [: arglist = [: argfirst = [: predicate = [: first = atloc,
													  : rest = [: first =
														    togoal,
														    : rest =
														    `[]]]]]]]]]].
when : [@ 'WHRELPP',
	: category = [: active = [: category = [: active = [: category = [: feature = adj]]]]],
	: semantics = [: arglist = [: argrest = [: argfirst = [: arglist = [: argfirst = [: predicate = [: first = temploc,
													 : rest = `[]]]]]]]]].
%PRONOUNS

'I' : [@ 'Perspron',
       : category = [: active = [: category = [: active = [: phonology = 'I',
							   : category = [: feature = [: case = nom,
										      : number = pl]],
							   :semantics = @ 'Ex']]]],
       : semantics = [: arglist = [: argrest = [: argfirst = [: arglist = [: argfirst = [: predicate = ego,
											 : arglist = `[]]]]]]]].

me : [@ 'Perspron',
      : category = [: active = [: category = [: active = [: category = [: feature = [: case = obj,
										     : number = pl]],
							  :semantics = @ 'Ex']]]],
      : semantics = [: arglist = [: argrest = [: argfirst = [: arglist = [: argfirst = [: predicate = ego,
											: arglist = `[]]]]]]]].

you : [: category = [: active = [: category = [: active = [: phonology = you,
							   : category = [: feature = [: number = pl]]]]]],
       : semantics = [: arglist = [: argrest = [: argfirst = [: arglist = [: argfirst = [: predicate = tu,
											 : arglist = `[]]]]]]]].
he : [@ 'Anaphor',
      : semantics : arg1 : term = @ 'Mal',
      : cat1 : cat1 : category : feature : case = nom].

him : [@ 'Anaphor',
       : semantics : arg1 : term = @ 'Mal',
       : cat1 : cat1 : category : feature : case = obj].

she : [@ 'Anaphor',
       : semantics : arg1 : term = @ 'Fem',
       : cat1 : cat1 : category : feature : case = nom].

her : [@ 'Anaphor',
       : semantics : arg1 : term = @ 'Fem',
       : cat1 : cat1 : category : feature : case = obj].

it : [@ 'Anaphor',
      : semantics : arg1 : term = @ 'NM'].

we : [@ 'PluralPerspron',
      : category = [: active = [: category = [: active = [: category = [: feature = [: case = nom]],
							  : semantics = @ 'Ex']]]],
      : semantics = [: arglist = [: argrest = [: argfirst = [: arglist = [: argrest = [: argrest = [: argfirst = [: predicate = ego,
														 : arglist = `[]]]]]]]]]].

us : [@ 'PluralPerspron',
      : category = [: active = [: category = [: active = [: category = [: feature = [: case = obj]],
							  :semantics = @ 'Ex']]]],
      : semantics = [: arglist = [: argrest = [: argfirst = [: arglist = [: argrest = [: argrest = [: argfirst = [: predicate =
														  ego,
														  : arglist =
														  `[]]]]]]]]]].
they : [@ 'PluralAnaphor',
	: cat1 : cat1 : category : feature : case = nom].

them : [@ 'PluralAnaphor',
	: cat1 : cat1 : category : feature : case = obj].

myself : [@ 'ReflexivePersPron',
	  : category = [: active = [: category = [: active = [: category = [: feature = [: case = obj]]]]]],
	  : semantics = [: arglist = [: argrest = [: argfirst = [: arglist = [: argfirst = [: predicate = ego,
											    : arglist = `[]]]]]]]].

yourself : [@ 'ReflexivePersPron',
	    : category = [: active = [: category = [: active = [: category = [: feature = [: case = obj]]]]]],
	    : semantics = [: arglist = [: argrest = [: argfirst = [: arglist = [: argfirst = [: predicate = tu,
											      : arglist = `[]]]]]]]].
himself : [@ 'Reflexive',
	   : cat1 : cat1 = @ 'Male1'].

herself : [@ 'Reflexive',
	   : cat1 : cat1 = @ 'Female1'].

itself : [@ 'Reflexive',
	  : cat1 : cat1 = @ 'Neuter1'].

themselves : [@ 'PluralReflexive'].

my : [@ 'Persposs',
      : semantics : arg2 : arg2 : arg1 : predicate = ego,
      : semantics : arg2 : arg2 : arg1 : index = @ 'Si'].

your : [@ 'Persposs',
	: semantics : arg2 : arg2 : arg1 : predicate = tu,
	: semantics : arg2 : arg2 : arg1 : index = @ 'Si'].

his : [@ 'Possanaphor',
       : semantics : arg1 : term = @ 'Mal'].

her : [@ 'Possanaphor',
       : semantics : arg1 : term = @ 'Fem'].

its : [@ 'Possanaphor',
       : semantics : arg1 : term = @ 'NM'].

our : [@ 'PluralPersposs',
       : semantics : arg2 : arg2 : arg3 : predicate = ego].

their : [@ 'PluralPossanaphor'].

mine : [@ 'Persgen',
	: semantics : arg2 : arg2 : arg1 : predicate = ego,
	: semantics : arg2 : arg2 : arg1 : index = @ 'Si'].

yours : [@ 'Persgen',
	 : semantics : arg2 : arg2 : arg1 : predicate = tu,
	 : semantics : arg2 : arg2 : arg1 : index = @ 'Si'].

his : [@ 'Persgen1',
       : semantics : arg1 : term = @ 'Mal'].

hers : [@ 'Persgen1',
	: semantics : arg1 : term = @ 'Fem'].

its : [@ 'Persgen1',
       : semantics : arg1 : term = @ 'NM'].

ours : [@ 'PluralPersgen',
	: semantics : arg2 : arg2 : arg3 : predicate = ego].

/* See comment above re persposs Mon Jan 18 10:21:26 1988 JC
yours: 	[@'Persgen'].

*/

theirs : [@ 'PluralPersgen1'].

%DEMONSTRATIVES

this : [@ 'Demonstrative',
	: cat1 : cat1 = @ 'Sing1'].

that : [@ 'Demonstrative',
	: cat1 : cat1 = @ 'Sing1'].

these : [@ 'PluralDemonstrative'].

those : [@ 'PluralDemonstrative'].

this : [@ 'Demodet',
	: semantics : arg2 : arg1 : index = @ 'Si'].

that : [@ 'Demodet',
	: semantics : arg2 : arg1 : index = @ 'Si'].

these : [@ 'PluralDemodet'].

those : [@ 'PluralDemodet'].

here : [@ 'Demonstrativepp'].

there : [@ 'Demonstrativepp'].


