% ALternative definition for get_dtr which is suggested when dealing
% with unknown words.  It does not allow a list-valued DTRS feature
% to have more than two elements --- this is convenient when you have
% a head whose SUBCAT feature is an uninstantiated variable (which can
% happen when dealing with unknown words)

get_dtr(head_dtr, Sign, Dtr) :- path(Sign, dtrs:head_dtr, Dtr), !.
get_dtr(Which, Sign, []) :- path(Sign, dtrs:Which, []).
get_dtr(Which, Sign, [A]) :- path(Sign, dtrs:Which, [A]).
get_dtr(Which, Sign, [A,B]) :- path(Sign, dtrs:Which, [A,B]).

get_all_dtrs(Sign,Head,Comps,Adjs,Fillers):-
  get_dtr(head_dtr, Sign, Head),
  get_dtr(comp_dtrs, Sign, Comps),
  get_dtr(adj_dtrs, Sign, Adjs),
  get_dtr(filler_dtrs, Sign, Fillers).

