%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%
%                   HPSG Grammar Development System:  HPSG-PL
%
%                            Version 1.0
%                            July 16, 1991
%
%                            Version 1.1
%                            October 30, 1991
%
%			     Version 1.2
%			     May 12, 1992
%
%			     Sandi Kodric
%                            Fred Popowich
%                            Carl M. Vogel
%
%  This system can be used for noncommercial purposes with the permission
%  of the authors.  The system may be obtained by:  
%          1) writing to the Natural Language Laboratory
%                            School of Computing Science, 
%                            Simon Fraser University,
%                            Burnaby, B.C., CANADA V5A 1S6, 
%       or 2) sending electronic mail to popowich@cs.sfu.ca.
%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%


:- op( 950, xfx, domain).
:- op( 950, xfx, has).
:- op( 950, xfx, type).
:- op( 950, xfx, rule).
:- op( 950, xfx, entry).         % modified Sep 17, 1991
:- op( 950,  fx, entry).
:- op( 950,  fx, ideal).
:- op( 950,  fx, unknown_word).  % modified Sep 17, 1991
:- op(  900, yfx, with).
:- op(  850, xfy, &).
:- op(  800, xfx, =).
:- op(  750,  fx, !).
:- op(  750,  fx, @).
:- op(  750, xfy, :).
:- op(  700, xfx, set).

%  parser.pl      - the chart parser
%  constraints.pl - for processing function calls/constraints that may appear
%                   within signs
%  treetool.pl    - contains a very simple interface to the TreeTool program
%  io.pl          - for input/output of sentences and debugging predicates
%  lex.pl         - lexical compiler
%  utils.pl       - utilities
%  alt.pl         - alternative definitions for some predicates

:- compile([lex,parser,constraints,utils,io,treetool]).

