/*---------------------------------------------------------------------------+
|        								     |
|        /mnt1/jo/Acord/Prototype/Upimp/Grams/determiners.def		     |
|        Created:           Mon Nov 24 18:36:44 1986			     |
|        By:                Jo Calder					     |
|        date of last edit: "Mon Nov 24 18:36:44 1986"			     |
|        								     |
|        QUANTIFIERS. DETERMINERS.  NEW VERSION				     |
|        								     |
+---------------------------------------------------------------------------*/

/*
Thu Feb 11 16:00:24 1988	mkr

In the following four definitions, the indices I and J used to be
instantiated.  This meant that sentences like "he is everywhere"
failed to parse because I:P:L would be instantiated by the copula to
@'Sta':true:[_].  Since the second clause of Copula1 is meant to be
predicative, the index of the subject NP would end up getting
instantiated with I as well.  Since an NP is not stative, unification
failed.  I would expect this fix to overgenerate NPs like "the
drivers everywhere go to Paris" but it doesn't for some reason.
*/

everywhere: [@'PP', @'State',
		:semantics = +(_:imp:[	X:true:[],
					J:and:[	J:[inloc,togoal]:[X],
						I:P:L]]),
		:cat1:cat1:semantics = :semantics:arg2:index,
		:semantics:arg1:index = @'Ne',
		:semantics:arg2:arg2 = :cat1:semantics,
		:cat1:cat1:category:feature = loc or adj,
		:out = :cat1:out].

nowhere:[@'PP', @'State',
		:semantics = +(_:imp:[	I:and:[	X:true:[],
						J:and:[ J:[inloc,togoal]:[X],
							I:P:L]],
					@'Sta':absurdum:[]]),
		:semantics:arg1:arg1:index = @'Ne',
		:cat1:cat1:semantics = :semantics:arg1:arg2:index,
		:semantics:arg1:arg2:arg2 = :cat1:semantics,
		:cat1:cat1:category:feature = loc or adj,
		:out = :cat1:out].

anywhere: [@'PP',
		:semantics = +(I:and:[	X:true:[],
					J:and:[	J:[inloc,togoal]:[X],
						I:P:L]]),
		:cat1:cat1:semantics = :semantics:arg2:index,
		:semantics:arg1:index = @'Ne',
		:semantics:arg2:arg2 = :cat1:semantics,
		:cat1:cat1:category:feature = loc or adj,
		:out = :cat1:out].

somewhere: [@'PP',
		:semantics = +(I:and:[	X:true:[],
 					J:and:[	J:[inloc,togoal]:[X],
						I:P:L]]),
		:semantics:arg1:index = @'Ne',
		:cat1:cat1:semantics = :semantics:arg2:index,
		:semantics:arg2:arg2 = :cat1:semantics,
		:cat1:cat1:category:feature = loc or adj,
		:out = :cat1:out].

everybody: [@'NP', @'State',
		:semantics = +(I:imp:[X:and:[ (X:_:_:indef:_), (X:human:[])], _]),
		:semantics:arg1:arg2:index = @'Hum',
		:semantics:arg1:arg1 = :cc1:occlist,
		:cat1:cat1:semantics = :semantics:arg1:arg2:index,
		:semantics:arg2 = :cat1:semantics,
		:semantics:arg1:arg1:position = :occnumber,
		:out = :cat1:out].

nobody: 	[@'NP', @'State',
		:semantics = +(_:imp:[I:and:[X:and:[ (X:_:_:indef:_), (X:human:[])],
					(I:P:L)],
						@'Sta':absurdum:[]]),
		:cat1:cat1:semantics = :semantics:arg1:arg1:arg2:index,
		:semantics:arg1:arg1:arg2:index = @'Hum',
		:semantics:arg1:arg2 = :cat1:semantics,
		:semantics:arg1:arg1:arg1:position = :occnumber,
		:semantics:arg1:arg1:arg1 = :cc1:occlist,
		:out = :cat1:out].

anybody: 	[@'NP',
		:semantics = +(I:and:[X:and:[ (X:_:_:indef:_), (X:human:[])],
				(I:P:L)]),
		:cat1:cat1:semantics = :semantics:arg1:arg2:index,
		:semantics:arg1:arg2:index = @'Hum',
		:semantics:arg2 = :cat1:semantics,
		:semantics:arg1:arg1 = :cc1:occlist,
		:semantics:arg1:arg1:position = :occnumber,
		:out = :cat1:out].

somebody:	 [@'NP', 
		:semantics = +(I:and:[X:and:[ (X:_:_:indef:_), (X:human:[])],
				(I:P:L)]),
		:cat1:cat1:semantics = :semantics:arg1:arg2:index,
		:semantics:arg1:arg2:index = @'Hum',
		:semantics:arg2 = :cat1:semantics,
		:semantics:arg1:arg1 = :cc1:occlist,
		:semantics:arg1:arg1:position = :occnumber,
		:out = :cat1:out].

everything: [@'NP', @'State',
		:semantics = +(I:imp:[X:and:[ (X:_:_:indef:_), (X:true:[])], _]),
		:semantics:arg1:arg2:index = @'Ne',
		:cat1:cat1:semantics = :semantics:arg1:arg2:index,
		:semantics:arg2 = :cat1:semantics,
		:semantics:arg1:arg1 = :cc1:occlist,
		:semantics:arg1:arg1:position = :occnumber,
		:out = :cat1:out].

nothing: 	[@'NP', @'State',
		:semantics = +(_:imp:[I:and:[X:and:[ (X:_:_:indef:_), X:true:[]],
				             I:P:L],
				      @'Sta':absurdum:[]]),
		:cat1:cat1:semantics = :semantics:arg1:arg1:arg2:index,
		:semantics:arg1:arg1:arg2:index = @'Ne',
		:semantics:arg1:arg2 = :cat1:semantics,
		:semantics:arg1:arg1:arg1 = :cc1:occlist,
		:semantics:arg1:arg1:arg1:position = :occnumber,
		:out = :cat1:out].

anything: 	[@'NP',
		:semantics = +(I:and:[X:and:[ (X:_:_:indef:_), (X:true:[])],
				(I:P:L)]),
		:cat1:cat1:semantics = :semantics:arg1:arg2:index,
		:semantics:arg1:arg2:index = @'Ne',
		:semantics:arg2 = :cat1:semantics,
		:semantics:arg1:arg1 = :cc1:occlist,
		:semantics:arg1:arg1:position = :occnumber,
		:out = :cat1:out].

something:	 [@'NP',
		:semantics = +(I:and:[X:and:[ (X:_:_:_indef:_), (X:true:[])],
				(I:P:L)]),
		:cat1:cat1:semantics = :semantics:arg1:arg2:index,
		:semantics:arg1:arg2:index = @'Ne',
		:semantics:arg2 = :cat1:semantics,
		:semantics:arg1:arg1 = :cc1:occlist,
		:semantics:arg1:arg1:position = :occnumber,
		:out = :cat1:out].

everyone: [@'NP', @'State',
		:semantics = +(I:imp:[X:and:[ (X:_:_:indef:_), (X:human:[])], _]),
		:semantics:arg1:arg2:index = @'Hum',
		:cat1:cat1:semantics = :semantics:arg1:arg2:index,
		:semantics:arg2 = :cat1:semantics,
		:semantics:arg1:arg1 = :cc1:occlist,
		:semantics:arg1:arg1:position = :occnumber,
		:out = :cat1:out].

noone: 	[@'NP', @'State',
		:semantics = +(_:imp:[I:and:[X:and:[ (X:_:_:indef:_), (X:human:[])],
					(I:P:L)],
						@'Sta':absurdum:[]]),
		:cat1:cat1:semantics = :semantics:arg1:arg1:arg2:index,
		:semantics:arg1:arg1:arg2:index = @'Hum',
		:semantics:arg1:arg2 = :cat1:semantics,
		:semantics:arg1:arg1:arg1 = :cc1:occlist,
		:semantics:arg1:arg1:arg1:position = :occnumber,
		:out = :cat1:out].

anyone: 	[@'NP',
		:semantics = +(I:and:[X:and:[ (X:_:_:indef:_), (X:human:[])],
				(I:P:L)]),
		:cat1:cat1:semantics = :semantics:arg1:arg2:index,
		:semantics:arg1:arg2:index = @'Hum',
		:semantics:arg2 = :cat1:semantics,
		:semantics:arg1:arg1 = :cc1:occlist,
		:semantics:arg1:arg1:position = :occnumber,
		:out = :cat1:out].

someone:	 [@'NP',
		:semantics = +(I:and:[X:and:[ (X:_:_:indef:_), (X:human:[])],
				(I:P:L)]),
		:cat1:cat1:semantics = :semantics:arg1:arg2:index,
		:semantics:arg1:arg2:index = @'Hum',
		:semantics:arg2 = :cat1:semantics,
		:semantics:arg1:arg1 = :cc1:occlist,
		:semantics:arg1:arg1:position = :occnumber,
		:out = :cat1:out].

1:	[@'Determiner', @'Indef', :cat2:cat1 = @'Sing1'].
one:	[@'Determiner', @'Indef', :cat2:cat1 = @'Sing1'].
a:	[@'Determiner', @'Indef', :cat2:cat1 = @'Sing1'].
generic:	[@'Determiner', @'Indef', :cat2:cat1 = @'Mpl1'].
an:	[@'Determiner', @'Indef', :cat2:cat1 = @'Sing1'].
any:	[@'Determiner', @'Indef', :cat2:cat1 = @'Object1'].
another:	[@'Determiner', @'Indef', :cat2:cat1 = @'Sing1'].
some:	[@'Determiner', @'Indef', :cat2:cat1 = @'Object1'].
many:	[@'Determiner', @'Indef', :cat2:cat1 = @'Plural1'].
2: [@'Cardinal',:semantics:arg2:arg1:arg2:arg1 = 2].
3: [@'Cardinal',:semantics:arg2:arg1:arg2:arg1 = 3].
4: [@'Cardinal',:semantics:arg2:arg1:arg2:arg1 = 4].
5: [@'Cardinal',:semantics:arg2:arg1:arg2:arg1 = 5].
6: [@'Cardinal',:semantics:arg2:arg1:arg2:arg1 = 6].
7: [@'Cardinal',:semantics:arg2:arg1:arg2:arg1 = 7].
8: [@'Cardinal',:semantics:arg2:arg1:arg2:arg1 = 8].
9: [@'Cardinal',:semantics:arg2:arg1:arg2:arg1 = 9].
10: [@'Cardinal',:semantics:arg2:arg1:arg2:arg1 = 10].
11: [@'Cardinal',:semantics:arg2:arg1:arg2:arg1 = 11].
12: [@'Cardinal',:semantics:arg2:arg1:arg2:arg1 = 12].
20: [@'Cardinal',:semantics:arg2:arg1:arg2:arg1 = 20].
50: [@'Cardinal',:semantics:arg2:arg1:arg2:arg1 = 50].
100: [@'Cardinal',:semantics:arg2:arg1:arg2:arg1 = 100].
200: [@'Cardinal',:semantics:arg2:arg1:arg2:arg1 = 200].
500: [@'Cardinal',:semantics:arg2:arg1:arg2:arg1 = 500].
1000: [@'Cardinal',:semantics:arg2:arg1:arg2:arg1 = 1000].

the: [@'Determiner', @'Definite'].
every: [@'Quantifier',
	:semantics:arg1:arg2 = :cat1:semantics,
	:cat2:cat1 = @'Sing1',
	:semantics:arg2= :cat2:semantics].
each: [@'Quantifier',
	:semantics:arg1:arg2 = :cat1:semantics,
	:semantics:arg2 = :cat2:semantics,
	:cat2:cat1 = @'Sing1'].


no: [	Word:C
		    /(_:C
			 /(m:np^F:U::[-generic]:O:_:_:OCC:_)
		      :(VIn:Pred:Args):O:I:O1:OCCV:_)
		/(_:noun:(U:V:W):pre:In:I:OCC:_):
	    _:	
	    _:
	    In:
	    Out:
	    OCCV:_,
	:semantics	= +(@'Sta':imp:[
				VIn:and:[U:and:[OCC, U:V:W], VIn:Pred:Args], 
					 (@'Sta':absurdum:[])]),
		:cat2:cat1 = @'Object1',
		:out = :cat2:out,
		:cat1:occlist:class = indef].

all: [Word:C
		    /(_:C
			 /(m:np^F:U::[-generic]:O:_:_: #9:_)
		      :S:O:XX:O1: OCCV:_)
		/(_:noun:(U:V:W):pre:In: XX: #9:_):
	    _:
	    _:
	    In:
	    Out:
	    OCCV:_,
	:semantics = +(I:and:[9#(_:_:_:def:_), I:and:[U:max:[U:V:W],(I:Q:M)]]),
	:semantics:arg2:arg2 = :cat2:semantics,
	:cat2:cat1 	= @'Mpl1',
	:out = :cat2:out].


