class(v,{a,e,i,o,u,y}).
class(c,{b,c,d,f,g,h,j,k,m,n,p,q,r,s,t,v,w,x,y,z}).
class(stops, {p,b,d,t,c,g,k,q}).
class(sibs, {c,s,x,z}).
class(semis, {w,y}).
class(voiced, {b,d,g,j,m,n,r,v,w,z}).
class(unvoiced, {c,f,h,k,p,q,s,t,x,y}).
class(alv, {t,d}).
class(liquids, {l,r}).
class(affricates, {g,j}).
class(nasals, {m,n}).

table( noun_regular,
	[noun, singular, morph_stem(Noun)],
	['PluralNoun'],
	[Noun + s]).
table( noun_in_o,
	[noun, singular, morph_stem(Noun),
	 Noun = Stem+o],
	['PluralNoun'],
	[Noun + es]).
table( noun_in_y,
	[noun, singular, morph_stem(Noun),
	 Noun = Stem+C+y,
	 C = `c],
	['PluralNoun'],
	[Stem + C + ies]).
table( children,
	[noun, singular, morph_stem(child)],
	['PluralNoun'],
	[children]).

table(	regular_verb,	% i.e. with long V in final syll
	[verb,bse,
	 morph_stem(Verb),
	 Verbs = Verb+s,
	 Verbed = Verb+ed,
	 Verbing = Verb+ing ],
	['3sg',	'Non3sg', 'Past', 'Perfect', 'Progressive',	'Passive'],
	[Verbs,	Verb,	  Verbed,   Verbed,    Verbing,		Verbed]).

table(	verb_in_e,	% locate,arrive,receive,realize,decide,like,ignore,
	[verb,bse,
	 morph_stem(Hik),morph_root(Hike),
	 Hike = Hik+e,
	 Hik = H+I+K,
	 I = `v,
	 K = `c,
	 K \= y,
	 Hikes = Hike+s,
	 Hiked = Hik+ed,
	 Hiking = Hik+ing ],
	['3sg',	'Non3sg', 'Past', 'Perfect', 'Progressive',	'Passive'],
	[Hikes,	Hike,	  Hiked,   Hiked,    Hiking,		Hiked]).

table(	age,		% Just to show pre-emption by a more specific table
	[verb,bse,
	 morph_stem(age),morph_root(age)],
	['3sg',	'Non3sg', 'Past', 'Perfect', 'Progressive',	'Passive'],
	[ages,	age,	  aged,	  aged,	     ageing,		aged     ]).

table(	hit,	% put
	[verb,bse, morphology(strong),
	 morph_stem(Hit),morph_root(Hit),
	 Hit = H+I+t,
	 Hi = H+I,
	 T = t,
	 I = `v,
	 Hits = Hit+s,
	 Hitting = Hi+T+T+ing],
	['3sg',	'Non3sg',	'Past',	'Perfect',	'Progressive',		'Passive'],
	[Hits,	Hit,	Hit,	Hit,	Hitting,	Hit]).

/*
table(	break,
	[verb,bse, morphology(strong),
	 morph_stem(Break),morph_root(Break),
	 Brake = Br+e+a+k,
	 K = `c,
	 K \= y,
	 Brakes = Brake+s,
	 Brak = Br+a+K,
	 Braking = Brak+ing,
	 Broke = Br+o+K+e,
	 Broken = Broke+n],
	['3sg',	'Non3sg',	'Past',	'Perfect',	'Progressive',		'Passive'],
	[Brakes,	Brake,	Broke,	Broken,	Braking,	Broken]).

*/
table(	ring,
	[verb,bse, morphology(strong),
	 morph_stem(Ring),morph_root(Ring),
	 Ring = R+i+ng,
	 Rang = R+a+ng,
	 Rung = R+u+ng,
	 Rings = Ring+s,
	 Ringing = Ring+ing],
	['3sg',	'Non3sg', 'Past', 'Perfect', 'Progressive', 'Passive'],
	[Rings,	Ring,	  Rang,	  Rung,	     Ringing,	    Rung]).

table(	come,
	[verb,bse,
	 morphology(strong),
	 morph_stem(Come),morph_root(Come),
	 Come = come,
	 Come = Com+e,
	 Come = C+o+Me,
	 Came = C+a+Me,
	 Me = M+e,
	 Comes = Come+s,
	 Coming = Com+ing],
	['3sg',	'Non3sg',	'Past',	'Perfect',	'Progressive'],
	[Comes,	Come,	Came,	Come,	Coming]).

table(	empty,	%carry
	[verb,bse,
	 morph_stem(Empty),morph_root(Empty),
	 Empty = Em+P+T+y,
	 Empt  = Em+P+T,
	 Em \= 0,
	 P = `c,
	 P \= y,
	 T = `c,
	 T \= y,
	 Empties = Empt+ies,
	 Emptied = Empt+ied,
	 Emptying = Empty+ing],
	['3sg',	 'Non3sg',	'Past',	 'Perfect',	  pas,	   'Progressive'],
	[Empties, Empty,	Emptied, Emptied, Emptied, Emptying]).

table(	leave,
	[verb,bse,
	 morph_stem(Leave),morph_root(Leave),
	 Leave = Le+A+v+e,
	 A = `v,
	 Leave = Leav+e,
	 Leav = Le+av,
	 Leaves = Leave+s,
	 Left = Le+ft,
	 Leaving = Leav+ing],
	['3sg',	'Non3sg',	'Past',	'Perfect',	'Progressive',	'Passive'],
	[Leaves,	Leave,	Left,	Left,	Leaving,	Left]).

table(	fetch,	%reach
	[verb,bse,
	 morph_stem(Fetch),morph_root(Fetch),
	 Fetch = Fet+C+h,
	 C = {c,s},
	 Fet = F+E+T,
	 E = `v,
	 T = {t,0},
	 Fetches = Fetch+es,
	 Fetched = Fetch+ed,
	 Fetching = Fetch+ing],
	['3sg',	'Non3sg',	'Past',	'Perfect',	'Progressive',	  'Passive'],
	[Fetches,Fetch,	Fetched,Fetched,Fetching, Fetched]).

table(	have,
	[verb,bse,
	 morphology(strong),
	 morph_stem(Have),morph_root(Have),
	 Have = have,
	 Have = Hav+e,
	 Having = Hav+ing],
	['3sg',	'Non3sg',	'Past',	'Perfect',	'Progressive',	'Passive'],
	[has,	Have,	had,	had,	Having,	had]).

table(	stop,
	[verb,bse,final_stress,
	 morph_stem(Stop),morph_root(Stop),
	 Stop = Sto+P,
	 P = `stops,
	 P \= `alv,
	 Stops = Stop+s,
	 Stopping = Sto+P+P+ing,
	 Stopped = Sto+P+P+ed],
	['3sg',	'Non3sg',	'Past',	'Perfect',	'Progressive',	'Passive'],
	[Stops,	Stop,	Stopped,Stopped,Stopping,	Stopped]).

table(	transfer,
	[verb,bse, final_stress,
	 morph_stem(Transfer),morph_root(Transfer),
	 Transfer = Transf+e+R,
	 R = r,
	 Transf+e = Transfe,
	 Transfers = Transfer+s,
	 Transferring = Transfe+R+R+ing,
	 Transferred = Transfe+R+R+ed],
	['3sg',     'Non3sg',	'Past',	     'Perfect',	  'Progressive',
	 'Passive'],
	[Transfers, Transfer,	Transferred, Transferred, Transferring,
	 Transferred]).

table(	delay,	% stay
	[verb,bse,
	 morph_stem(Delay),morph_root(Delay),
	 Delay = Del+A+Y,
	 A = {a,e,o,u},
	 Y = {w,y},
	 Delays = Delay+s,
	 Delayed = Delay+ed,
	 Delaying = Delay+ing],
	['3sg',	'Non3sg',	'Past',	'Perfect',	'Progressive'],
	[Delays,	Delay,	Delayed,Delayed,Delaying]).

table(	bring,
	[verb,bse,morphology(strong),
	 morph_stem(Bring),morph_root(Bring),
	 Bring = bring,
	 Bring = Br+ing,
	 Brings = Bring+s,
	 Brought = Br+ought,
	 Bringing = Bring+ing],
	['3sg',	'Non3sg',	'Past',	'Perfect',	'Progressive',	'Passive'],
	[Brings,	Bring,	Brought,Brought,Bringing,Brought]).

table(	go,
	[verb,bse, morphology(strong),
	 morph_stem(Go),morph_root(Go),
	 Go = go],
	['3sg',	'Non3sg',	'Past',	'Perfect',	'Progressive'],
	[goes,	Go,		went,	gone,		going]).

table(	drive,
	[verb,bse,morphology(strong),
	 morph_stem(Drive),morph_root(Drive),
	 Drives = Drive+s,
	 Drive = Dr+i+ve,
	 Drove = Dr+o+ve,
	 Driven = Drive+n,
	 Drive = Driv+e,
	 Driv = Dr+iv,
	 Driving = Driv+ing],
	['3sg',	'Non3sg',	'Past',	'Perfect',	'Progressive',	'Passive'],
	[Drives,	Drive,	Drove,	Driven,	Driving,Driven]).

table(	get,
	[verb,bse,morphology(strong),
	 morph_stem(Get),morph_root(Get),
	 Gets = Get+s,
	 Get = G+e+T,
	 T = t,
	 Got = G+o+T,
	 Getting = G+e+T+T+ing],
	['3sg',	'Non3sg',	'Past',	'Perfect',	'Progressive',	'Passive'],
	[Gets,	Get,	Got,	Got,	Getting,Got]).

table(	cost,
	[verb,bse,morphology(strong),
	 morph_stem(Cost),morph_root(Cost),
	 Costs = Cost+s],
	['3sg',	'Non3sg',	'Past'],
	[Costs,	Cost,		Cost]).

table(	send,
	[verb,bse,
	 morph_stem(Send),morph_root(Send),
	 Sends = Send+s,
	 Send = Se+nd,
	 Sent = Se+nt,
	 Sending = Send+ing],
	['3sg',	'Non3sg',	'Past',	'Perfect',	'Progressive',	'Passive'],
	[Sends,	Send,	Sent,	Sent,	Sending,Sent]).

table(	die,
	[verb,bse,
	 morph_stem(Die),morph_root(Die),
	 Die = D+ie,
	 Dies = Die+s,
	 Died = Die+d,
	 Dying = D+ying],
	['3sg',	'Non3sg',	'Past',	'Perfect',	'Progressive'],
	[Dies,	Die,	Died,	Died,	Dying]).

table(	buy,
	[verb,bse,morphology(strong),
	 morph_stem(Buy),morph_root(Buy),
	 Buy = B+uy,
	 Bought = B+ought,
	 Buying = Buy+ing,
	 Buys = Buy+s],
	['3sg',	'Non3sg',	'Past',	'Perfect',	'Progressive',	'Passive'],
	[Buys,	Buy,	Bought,	Bought,	Buying,	Bought]).

