/* 
rcsid('$Id: slemenus.pl,v 1.60 1993/05/04 09:43:01 pleuk Exp $').
$Log: slemenus.pl,v $
% Revision 1.60  1993/05/04  09:43:01  pleuk
% Version 1.00beta from Jo
%
% Revision 1.5  1992/04/16  13:44:43  pleuk
% revisions from SLE - April 1992
%
% Revision 1.3  1992/02/11  10:29:14  chrisbr
% Changes to parser and debugging routines. Dead code removed
%
% Revision 1.2  1992/01/29  16:03:26  chrisbr
% Jo's changes integrated with SLE's
%
 */

/* Template expansion overflow menu */
eccs_specialization_menu(overflow, popup,
	[prompt = 'Template expansion limit exceeded. Action?',
	 exit_command = cuttrue,
	 options = [command('Continue', true),
	 	    command('Trace', trace),
	 	    command('Fail', fail), '$$LINE']]).

/* Generation menu -- exists if the parser is sle_satisfy_phon, which only
 * supports generation of known length strings. 
 */    
eccs_specialization_menu(generate, popup, 
	[options = 
	   [command('Generate a string of known length', eccs_do_generate),
	    '$$DEBUG_OPTIONS'],
	 prompt = 'Generate']) :-
    eccs_global_variable(parser, eccs_sle_satisfy_phon).

eccs_specialization_menu(generatedbox, dbox,
	[fields = [field('Length of string', 3)],
	 command = eccs_generate('$$', _),
	 prompt = 'Generate']).


/* Debugging menu.
   Provides  1) Access to chart
             2) Access to execution profiling
             3) Facilities for accessing the Prolog code which implements Pleuk.
             4) Facilities for running tests of system integrity.
   We should probably make the debugging menu generally available, but for the
   moment is is only in the top level.
% now in all analysis submenus - kwh 2/4/92  
  */
eccs_specialization_menu(debug, popup,
	[options = [ command('Diagram of chart', 
	                     eccs_show_debug_chart),
                     command('Show a chart edge', 
                             eccs_do_menu(dbox,
                             [ fields = [field('ID of the chart edge:', '')],
			     command=sle_edge_show('$$')])),
                     '$$LINE',
% Profiling facilities are not worth having yet
% command('Begin Profiling', sle_profile_start),      /* Code in sledebug.pl */
% command('End Profiling', sle_profile_stop),         /* Code in sledebug.pl */
% '$$LINE',
                     command('Run system tests', test_assertions),
                     '$$LINE',
                     command('Find a predicate', 
                             eccs_do_menu(dbox,
                             [ fields = [field('Predicate to find:', '')],
			     command=sle_predicate('$$')])),
                     command('List a predicate', 
                             eccs_do_menu(dbox,
                             [ fields = [field('Predicate to list:', '')],
			     command=listing('$$')])),
                     command('Edit a predicate', 
	                     eccs_do_menu(dbox,
                             [ fields = [field('Predicate to edit:', '')],
                             command=eccs_edit_source_file('$$')])),
                     '$$LINE',
                     command('Spy a template', 
             		     eccs_do_menu(dbox,
                             [ fields = [field('Template to spy:', '')],
		             command=template_spy('$$')])),
                     command('Unspy a template', 
                             eccs_do_menu(dbox,
                             [ fields = [field('Template to unspy:', '')],
			     command=template_unspy('$$')])),
		     '$$PROLOG'
                ],
		stayhere = true,
		prompt = 'Debugging']).

% prolog options added by kwh - 2/4/92
% (seemed like a useful thing to have in a debug menu)






